// LinkDialog.cpp : implementation file
//

#include "stdafx.h"
#include "MyHtmlApp.h"
#include "LinkDialog.h"
#include <mshtml.h> 
#include <comdef.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CLinkDialog dialog


CLinkDialog::CLinkDialog(CWnd* pParent /*=NULL*/)
	: CDialog(CLinkDialog::IDD, pParent)
{
	//{{AFX_DATA_INIT(CLinkDialog)
	m_strLink = _T("");
	//}}AFX_DATA_INIT
}


void CLinkDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CLinkDialog)
	DDX_Control(pDX, IDC_LINK_LIST, m_lbLinkList);
	DDX_LBString(pDX, IDC_LINK_LIST, m_strLink);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CLinkDialog, CDialog)
	//{{AFX_MSG_MAP(CLinkDialog)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CLinkDialog message handlers

BOOL CLinkDialog::OnInitDialog() 
{
	CDialog::OnInitDialog();
	//    

	CFrameWnd * pFrame = dynamic_cast<CFrameWnd *>( AfxGetMainWnd());
	ASSERT_VALID( pFrame );

	CHtmlView * pHtmlView = dynamic_cast<CHtmlView *>( pFrame->GetActiveView());
	ASSERT_VALID( pHtmlView );

       //     
       //  
	IDispatch * pDisp = pHtmlView->GetHtmlDocument();
	
	if( pDisp != NULL )
	{
		//     IHTMLDocument2 
		//       
		IHTMLDocument2 * pHTMLDocument2;
		HRESULT hr;

		hr = pDisp->QueryInterface( IID_IHTMLDocument2,
			(void**)&pHTMLDocument2 );
		
		if( hr == S_OK )
		{
			//     
			IHTMLElementCollection * pColl = NULL;
			hr = pHTMLDocument2->get_anchors( &pColl );

			if( hr == S_OK && pColl != NULL )
			{
				LONG nElem;
				hr = pColl->get_length( &nElem );

				if( hr == S_OK )
				{
					//   
					for( long i = 0; i < nElem; i++ )
					{
						_variant_t vIndex( i );
						_variant_t vName = vIndex;
						
						IDispatch * pDisp2;

						hr = pColl->item( vName, vIndex, &pDisp2 );
						if( hr == S_OK )
						{
                                                        //     
                                                        //   <Anchor>  
                                                        //  URL-   
                                                        //   
							IHTMLAnchorElement * pAnchElem;
							
							hr = pDisp2->QueryInterface( 
								IID_IHTMLAnchorElement,(void**) &pAnchElem );
							if( hr == S_OK )
							{
								BSTR bstrHref = 0;
								pAnchElem->get_href( &bstrHref );

								CString strLink( bstrHref );
								
								if( !strLink.IsEmpty() )
									m_lbLinkList.AddString( strLink );
								
								SysFreeString( bstrHref );
								pAnchElem->Release();
							}

							pDisp2->Release();
						}
					}
				}

				pColl->Release();
			}

			pHTMLDocument2->Release();
		}

		pDisp->Release();
	}

	
	return TRUE;  
        //  TRUE,    
        //     
        // : OCX-  
        //   FALSE 
	
}
